// Copyright 2021 Juan Pablo Tosso
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package utils

import (
	"testing"
)

func TestUnicode(t *testing.T) {
	uni, err := NewUnicode("20127")
	if err != nil {
		t.Error("invalid unicode mapping default")
		return
	}
	if uni.At(0x00a1) != 0x21 {
		t.Error("Invalid unicode character")
	}
}
